module Thingdeck
  class NestedItem
    def initialize(wrapper, parent, uri)
      @wrapper = wrapper
      @parent = parent
      @uri = uri
    end

    def all(pid, params = {})
      @wrapper.perform_request { |c| c.get(url(pid), params) }
    end

    def find(pid, id, params = {})
      @wrapper.perform_request { |c| c.get(url(pid, id), params) }
    end

    def update(pid, id, params)
      @wrapper.perform_request { |c| c.put(url(pid, id),  params) }
    end

    def create(pid, params)
      @wrapper.perform_request { |c| c.post(url(pid), params) }
    end

    def destroy(pid, id)
      @wrapper.perform_request { |c| c.delete(url(pid, id)) }
    end

    private
    def url(pid, id = '')
      '/' + [ @parent, pid, @uri, id ].join('/')
    end
  end
end
